function length_of_file(filename)
    local f = assert(io.open(filename, "rb"))
    local len = assert(f:seek("end"))
    f:close()
    return len
end

function file_exists(filename)
    local f = io.open(filename, "rb")
    if f then f:close() end
    return f ~= nil
end

function get_file(filename,pos,size)
    local filepos,filesize,filelength,filestr
    if file_exists(filename) then
        filelength=length_of_file(filename)
        local f = assert(io.open(filename, "rb"))
        if pos  then filepos=pos else filepos=0 end
        if size then filesize=math.min(size,filelength-filepos) else filesize=filelength-filepos end
        f:seek("set", pos)
        filestr = f:read(filesize);
        if filestr == nil then return "" end
        f:close()
        return filestr
    else return ""
    end
end

function rewrite_file(filename,str)
    local f = assert(io.open(filename, "w+b"))
    if f then
        f:write(str)
        f:close()
    end
    return f ~= nil
end

--function append_file(filename,str)
--  local f = assert(io.open(filename, "w+b"))
--  if f then
--      f:write(str)
--      f:close()
--  end
--  return f ~= nil
--end


function get_hiewfile(pos,size)
    local filesize
    if size then filesize=size else filesize=hiew.filesizelo end
    return get_file(hiew.filename,pos,filesize)
end

function put_hiewfile(str)
    return rewrite_file(hiew.filename,str)
end